/**
 * This is a very small example that shows how to use Catalina
 * threads. The program consists of two threads that wait
 * for each other to toggle a variable.
 */

#include <catalina_threads.h>

#include <thread_utilities.h>

#define STACK_SIZE 100

#include <stdio.h> 

static int lock;

/* Two flags that the two thread functions use. */
static int thread1_flag, thread2_flag;

/**
 * The first thread function. 
 */
static int
thread1(int me, char *not_used[])
{
  /* We loop forever here. */
   while(1) {

    /* Wait until the other thread has set its flag. */
    while (thread2_flag != 0) {
       thread2_flag = 0;
       _thread_yield();
    }
    _thread_printf(lock, "thread 1 running\n");

    /* We set our own flag so that the other thread can run. */
    thread1_flag = 1;

  }
  return 0;
}

/**
 * The second thread function. 
 */
static int
thread2(int me, char *not_used[])
{
  /* We loop forever here. */
   while(1) {

    /* Wait until the other thread has set its flag. */
    while (thread1_flag != 0) {
       thread1_flag = 0;
       _thread_yield();
    }
    _thread_printf(lock, "thread 2 running\n");
    
    /* We set our own flag so that the other thread can run. */
    thread2_flag = 1;

  }
  return 0;
}

void main(void)
{
   int i;
   unsigned long stacks[STACK_SIZE * 2];

   // assign a lock (used to avoid printf contention)
   lock = _locknew();

   // start the threads
   _thread_start(&thread1, &stacks[STACK_SIZE], 1, NULL);
   _thread_start(&thread2, &stacks[STACK_SIZE*2], 2, NULL);

  // and loop forever  
  while(1) {
     _thread_yield();
  }
}
